# 4.0.0

Migration path

- search and replace all uses of all method names, and method signatures
- replace the use of saveUrl state, to a history handled by the main program

## Breaking changes

- Rename MainBluePrint to ProgramBluePrint

- Changed all method signatures to named arguments

- Rename BrowserDevice.setUrl to BrowserDevice.setPath

- Rename BrowserDevice.saveUrl to BrowserDevice.gotoPathLocally

- Rename BrowserDevice.gotoUrl to BrowserDevice.gotoPath

- Removed the state parameters from the url history

  That's something for each program to handle it

- Removed method ProgramBluePrint.aboutToRender

- Removed method ProgramBluePrint.syncFromUrl

- Removed method ProgramBluePrint.urlHasChanged

## Not breaking fix

- Add getBrowserDevice/setBrowserDevice methods

- Re-style source code format using stylist

- Re-write tests using o-check-list

# 3.1.0

## Not breaking fix

- Upgrade libraries

## Not breaking changes

- Add MainBluePrint.createUID()

# 3.0.0

## Breaking changes

- Rename getUUID to getUID

## Not breaking fix

- Upgrade libraries

# 2.0.7

- Link to documentation

# 2.0.6

## Not breaking fix

- upgrade libraries

- Upgrade libraries



# v2.0.5

## Not breaking changes

- Upgrade dependencies

# v2.0.4

## Not breaking changes

- Upgrade dependencies

# v2.0.0

## Breaking changes

-` BluePrint` classes must implement a method named `getRenderMethodName()`

To migrate from v1.0.0 in every BluePrint subclass create a method

```javascript
class Something extends BluePrint {
  // ...

  getRenderMethodName() {
    return 'renderSomething'
  }  

  // ...
}
```

- Router.getRenderMethodName() does not use the BluePrint class name any more.
  Instead it asks for the method name to the BluePrint.
  This change allows routing when the runtime does not preserve class names, mostly
  React apps deployed in production mode where js files are minified.