class BrowserDevice {
  gotoPath ({ path }) {
    window.location = path
  }

  gotoPathLocally ({ path }) {
    window.history.pushState(
      undefined,
      '',
      path
    )
  }

  setPath ({ path }) {
    window.location.replace( path )
  }

  getCurrentUrl () {
    const location = this.getCurrentLocation()

    return new URL( location )
  }

  getCurrentLocation () {
    return window.location.toString()
  }

  getCurrentPath () {
    return this.getCurrentUrl().pathname
  }
}

module.exports = BrowserDevice